# gophian -- tools to help with Debianizing Go software
# Copyright (C) 2024-2025 Maytham Alsudany <maytha8thedev@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

import subprocess

from click import ClickException


class GophianError(ClickException):
    def __init__(self, *args) -> None:
        super().__init__(*args)


class ExecutionError(subprocess.CalledProcessError):
    def __init__(self, out: subprocess.CompletedProcess[bytes]):
        super().__init__(out.returncode, out.args)


class GoExecutionError(ExecutionError):
    pass


class GitExecutionError(ExecutionError):
    pass


class GbpExecutionError(ExecutionError):
    pass


class UscanExecutionError(ExecutionError):
    pass
